#!/bin/sh
SUD_INSTALL_DIR=/opt/sentinel/sud
MAJOR=6
MINOR=4
REV=0
version=6.4.0
SUD_VER=710
sud_version=7.1.0
SUD_RPM=sntl-sud

#
# This script uninstalls both parallel driver & usb daemon.
#

###############################################################################
#                      Check for Dependencies
###############################################################################
check_dep()
{
	#check for super user
	user_id=`id -u`
	if [ $user_id -ne 0 ]
	then
		echo "WARNING:To Install this software make sure you have Super User (root) permission."  
		echo "Installation Aborted."
		exit
	fi
}

showbanner()
{ 
	echo "-------------------------------------------------------------------------------"
	echo "              Sentinel Unix Driver $sud_version Un-Installation Script"
	echo "                         Copyright (C) 2005 SafeNet, Inc."              
	echo "                             All rights reserved."
	echo "-------------------------------------------------------------------------------"
}



################################################################################
##                 Start Here
################################################################################
  
  check_dep
  if [ "$1" != "nobanner" ] ; then
	showbanner
  fi
  
	rpm -q $SUD_RPM-$sud_version > /dev/null 2>&1
    if [ $? -eq 0 ]
    then
		rpm -e $SUD_RPM-$sud_version > /dev/null 2>&1
		if [ $? -ne 0 ]
		then 
	    	echo "Failed to remove SUD as there might be a component which is dependent on SUD"
		else 
			echo "Sentinel Unix Driver uninstalled successfully"
		fi
    else
		echo Sentinel Unix Driver $sud_version package not installed.
    fi
  echo "-------------------------------------------------------------------------------"
  
  
  
