/***************************************************************************
* KeyInfoApplet.java
*
* (C) Copyright 2004 SafeNet, Inc. All rights reserved.
*
*
* Purpose     : To display the keys details attached on the server using keyinfo.xml.
*
* Refer to the ReadMe.pdf for customize details of Sentinel License Monitor.
*
****************************************************************************/

//imports
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import java.util.*;
import java.io.*;
import java.net.*;
import javax.swing.border.*;


/**
*The Main Applet display the key information
*/
public class KeyInfoApplet extends Applet implements ActionListener{
//file to request from server for keys details
  static public final String KEYS_INFO_XML_FILE = "keyinfo.xml";

  ResourceBundle              resourceBundle;
  //boolean variable for check the resource bundle
  boolean   isResourceBundleFound = false;
  Panel mCenterPanel          = new Panel();
  Panel mSouthPanel           = new Panel();
  Panel mNorthPanel           = new Panel();
  GridLayout gridLayout1      = new GridLayout();
  GridLayout gridLayout3      = new GridLayout();

  BorderLayout borderLayout1  = new BorderLayout();

  Label mTopHeadingLabel      = new Label();
  Label SysAddStaticLabel     = new Label();
  Label mSSPVersionLabel      = new Label();
  Label KeyLine1Heading       = new Label();
  Label KeyLine2Heading       = new Label();
  Label mKeyFootNoteLabel     = new Label();
  Label mCopyrightLabel       = new Label();
  Label KeylblError           = new Label();

  KeysRow headingRow          = new KeysRow();

  String tmpString            = new String();
  String xmlBuffer            = new String("");
  Vector vKeysRow             = new Vector(2,1);
  Vector tmpVector            = new Vector(2,1);

  URL codeBase;
  KeysRow kKeysDetails;
  JButton mRefresh = new JButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();


  //Construct the applet
  public KeyInfoApplet() {
  }
  //Initialize the applet
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

/**
* Method to pad the serial number.
*/
  static public String PadSerialNumber(int input) {

    int width = 8; //pad for 8 digit wide
    //convert the serial number into the hex to display
    String output = Integer.toHexString(input);
    //convert to uppercase
    output = output.toUpperCase();

    for (int i = width - output.length(); i > 0; i--) {
      output = "0" + output;
    }
    //prefix it with the 0x
    output = "0x" + output;
    return output;
  }

  /**
  *Function to fill the data into the rows
  */
  private void fillRow(int iTotalKeysDetails)
  {
    XMLParser xParser = new XMLParser();
    String  strSerialNumber;
    try{
      KeysRow tmpKeysRow = new KeysRow();
      //fill the Keys#

      for (int k = 0; k < iTotalKeysDetails; k++) {
        tmpKeysRow = (KeysRow) vKeysRow.get(k);
        tmpString = String.valueOf(k + 1);
        tmpKeysRow.lblKeysH.setText(tmpString);
        tmpKeysRow.lblKeysH.setForeground(Color.blue);

      }
      tmpVector = xParser.getXMLTagValue(xmlBuffer, "SerialNumber");
      for (int k = 0; k < iTotalKeysDetails; k++) {
        tmpKeysRow = (KeysRow) vKeysRow.get(k);
        strSerialNumber = tmpVector.elementAt(k).toString();
        //store the serial number in decimal
        tmpKeysRow.serialNumber = Integer.parseInt(strSerialNumber);
        //pad the serial number to display
        strSerialNumber = PadSerialNumber(tmpKeysRow.serialNumber);
        tmpKeysRow.lblSerialNumber.setText(strSerialNumber);
      }

      tmpVector = xParser.getXMLTagValue(xmlBuffer, "KeyType");
      for (int k = 0; k < iTotalKeysDetails; k++) {
        tmpKeysRow = (KeysRow) vKeysRow.get(k);
        /*
         The KeyType values are as follows:
           0 - for SuperPro keys
           1 - for UltraPro Keys
         */
        if(Integer.parseInt(tmpVector.elementAt(k).toString()) == 1){
          tmpKeysRow.lblKeyType.setText("UltraPro");
        }else
          tmpKeysRow.lblKeyType.setText("SuperPro");
      }

      tmpVector = xParser.getXMLTagValue(xmlBuffer, "HardLimit");
      for (int k = 0; k < iTotalKeysDetails; k++) {
        tmpKeysRow = (KeysRow) vKeysRow.get(k);
        tmpKeysRow.lblHardLimit.setText(tmpVector.elementAt(k).toString());
      }

      tmpVector = xParser.getXMLTagValue(xmlBuffer, "LicenseInUse");
      for (int k = 0; k < iTotalKeysDetails; k++) {
        tmpKeysRow = (KeysRow) vKeysRow.get(k);
        tmpKeysRow.lblLicInUse.setText(tmpVector.elementAt(k).toString());
      }
      tmpVector = xParser.getXMLTagValue(xmlBuffer, "HighestUse");
      for (int k = 0; k < iTotalKeysDetails; k++) {
        tmpKeysRow = (KeysRow) vKeysRow.get(k);
        tmpKeysRow.lblHighestUse.setText(tmpVector.elementAt(k).toString());
      }
      tmpVector = xParser.getXMLTagValue(xmlBuffer, "NumTimeOut");
      for (int k = 0; k < iTotalKeysDetails; k++) {
        tmpKeysRow = (KeysRow) vKeysRow.get(k);
        tmpKeysRow.lblNumTimeOut.setText(tmpVector.elementAt(k).toString());
      }

      tmpVector = xParser.getXMLTagValue(xmlBuffer, "PartNumber");
      if (!tmpVector.isEmpty()) {
        for (int k = 0; k < iTotalKeysDetails; k++) {
          tmpKeysRow = (KeysRow) vKeysRow.get(k);
          tmpKeysRow.lblPartNumber.setText(tmpVector.elementAt(k).toString());
        }
      }

      //Add the keys row panel in the mCenterPanel
      for (int k = 0; k < iTotalKeysDetails; k++) {
        mCenterPanel.add( ( (KeysRow) vKeysRow.get(k)), null);
      }
    }catch(Exception ex){

    }
  }

/**
   * The Method to get the keyinfo.xml file from the server
   * */

void getKeyInfoXML_File_from_Server(){
 String inputLine = null;
 try{
   URL rURL = new URL(getCodeBase() + this.KEYS_INFO_XML_FILE);

   BufferedReader in = new BufferedReader(
                           new InputStreamReader(
                           rURL.openStream()));

   //get the contents of xml file in the buffer
   while ((inputLine = in.readLine()) != null)
   xmlBuffer = xmlBuffer + inputLine;

   in.close();  //close the BufferReader
   }catch (Exception ex) {
   }
 }

  /**
  *Applet initialization method
  */
  private void jbInit() throws Exception {
    //initialize the strings
    String mKeyFooNoteLabel1Str = new String("Not available. The part number cannot be obtained for certain keys. Please contact your developer/vendor for more information.");
    String KeylblErrorStr = new String("No Keys details available");
    String SysAddStaticLabelStr = new String("System Address: ");
    String mSSPVersionLabelStr = new String("Sentinel Protection Server Version ");
    String XMLFileErrorStr = new String("Error in downloading the key information file.");
    try{
      resourceBundle = ResourceBundle.getBundle("AppletResources");
                                                //, Locale.getDefault());
      //check if the resource bundle is present
      String testString = resourceBundle.getString("key");
      isResourceBundleFound = true;
    }catch (MissingResourceException e){
//      e.printStackTrace();
      isResourceBundleFound = false;
    }catch (NullPointerException en){
//    en.printStackTrace();
      isResourceBundleFound = false;
    }

    //check if the resource bundle is found
    if(isResourceBundleFound == true)
    {
      mTopHeadingLabel.setText(resourceBundle.getString("mTopHeadingLabel"));
      mSSPVersionLabelStr = resourceBundle.getString("mSSPVersionLabel");
      KeyLine1Heading.setText(resourceBundle.getString("KeyLine1Heading"));
      KeyLine2Heading.setText(resourceBundle.getString("KeyLine2Heading"));
      mCopyrightLabel.setText(resourceBundle.getString("mCopyrightLabel"));
      mRefresh.setText(resourceBundle.getString("mRefresh"));
      mKeyFooNoteLabel1Str = resourceBundle.getString("mKeyFootNoteLabel");
      KeylblErrorStr = resourceBundle.getString("KeylblError");
      SysAddStaticLabelStr = resourceBundle.getString("SysAddStaticLabel");
      XMLFileErrorStr = resourceBundle.getString("XMLKeyFileError");

    }else
    {
      mTopHeadingLabel.setText("Sentinel License Monitor");
      SysAddStaticLabel.setText("System Address: ");
      KeyLine1Heading.setText("This web page shows you details of the keys attached to the system.");
      KeyLine2Heading.setText("Please click on a key number to view the details about the clients who are using the licenses available with this key.");
      mCopyrightLabel.setText("Copyright 2004 SafeNet, Inc.");
      mRefresh.setText("Refresh");
    }

    this.setLayout(borderLayout1);
    mNorthPanel.setLayout(gridLayout1);
    mTopHeadingLabel.setBackground(SystemColor.activeCaption);
    mTopHeadingLabel.setFont(new java.awt.Font("Serif", 1, 24));
    mTopHeadingLabel.setForeground(Color.white);
    gridLayout1.setColumns(0);
    gridLayout1.setRows(3);
    SysAddStaticLabel.setFont(new java.awt.Font("Serif",1, 14));
    SysAddStaticLabel.setForeground(SystemColor.activeCaption);
    mSSPVersionLabel.setFont(new java.awt.Font("Serif", 1, 14));
    mSSPVersionLabel.setForeground(SystemColor.activeCaption);
    mCenterPanel.setLayout(gridLayout3);
    KeyLine1Heading.setFont(new java.awt.Font("Serif", 1, 14));
    KeyLine1Heading.setForeground(SystemColor.activeCaption);

    KeyLine2Heading.setFont(new java.awt.Font("Serif", 1, 14));
    KeyLine2Heading.setForeground(SystemColor.activeCaption);
    KeylblError.setFont(new java.awt.Font("Serif", 1, 14));
    KeylblError.setForeground(new Color(203, 0, 0));
    KeylblError.setVisible(false);
    gridLayout3.setRows(13);
    this.setBackground(Color.white);
    mNorthPanel.setBackground(Color.white);
    mCenterPanel.setBackground(Color.white);
    headingRow.setBackground(Color.white);
    headingRow.setFont(new java.awt.Font("Serif", 0, 14));
    headingRow.setForeground(new Color(0, 0, 90));
    mSouthPanel.setBackground(Color.white);
    mSouthPanel.setLayout(gridBagLayout1);


    //The * is the mark for footnote.
    String footNote = new String("* ");
    footNote = footNote + mKeyFooNoteLabel1Str;
    mKeyFootNoteLabel.setText(footNote);
    mKeyFootNoteLabel.setBackground(Color.white);
    mKeyFootNoteLabel.setFont(new java.awt.Font("Serif", 0, 14));
    mKeyFootNoteLabel.setForeground(new Color(0, 0, 90));

    mCopyrightLabel.setBackground(Color.white);
    mCopyrightLabel.setFont(new java.awt.Font("Serif", 0, 14));
    mCopyrightLabel.setForeground(new Color(0, 0, 90));

    mRefresh.setMinimumSize(new Dimension(90, 25));
    mRefresh.setPreferredSize(new Dimension(90, 25));
    mRefresh.addActionListener(this);
    mCenterPanel.add(KeyLine1Heading, null);
    mCenterPanel.add(KeyLine2Heading, null);
    mCenterPanel.add(KeylblError, null);
    mCenterPanel.add(headingRow, null);

    JScrollPane mScrollPane = new JScrollPane();
    this.add(mScrollPane, BorderLayout.CENTER);
    mScrollPane.getViewport().add(mCenterPanel, null );

    this.add(mNorthPanel, BorderLayout.NORTH);
    mNorthPanel.add(mTopHeadingLabel, null);
    mNorthPanel.add(SysAddStaticLabel, null);
    mNorthPanel.add(mSSPVersionLabel, null);
    this.add(mCenterPanel, BorderLayout.CENTER);
    this.add(mSouthPanel,  BorderLayout.SOUTH);
    mSouthPanel.add(mKeyFootNoteLabel,     new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    mSouthPanel.add(mCopyrightLabel,    new GridBagConstraints(0, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    mSouthPanel.add(mRefresh,     new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));


    //Request for the keyinfo.xml file to server
    try {
     codeBase = getCodeBase();
     getKeyInfoXML_File_from_Server();

     XMLParser xParser = new XMLParser();

      //set the server version
      Vector serverDetails = new Vector(2,1);
      serverDetails = xParser.getXMLTagValue(xmlBuffer, "ServerVersion");
      if(!serverDetails.isEmpty()){
	 mSSPVersionLabelStr = mSSPVersionLabelStr + serverDetails.elementAt(0); //the server version
         mSSPVersionLabel.setText(mSSPVersionLabelStr);
      }else{ //not able to extract the server version
	 mSSPVersionLabelStr = mSSPVersionLabelStr + "7.0.0"; //hard code server version
         mSSPVersionLabel.setText(mSSPVersionLabelStr);
      }
      serverDetails = null;

      //get the number of keys Info in file
      tmpVector = xParser.getXMLTagValue(xmlBuffer, "KeyDetails");
      if(tmpVector.isEmpty()){
        //Give the message for no keys details found in the xml file.
//        String msg = new String();
//        msg = KeylblErrorStr;
        KeylblError.setText(KeylblErrorStr);
        KeylblError.setVisible(true);
        //return;
      }else{
        int iTotalKeysDetails = 0;

        iTotalKeysDetails = tmpVector.size();
        //Manipulation with the rowss
        if (iTotalKeysDetails > 9)
          gridLayout3.setRows(iTotalKeysDetails + 4);

        for (int k = 0; k < iTotalKeysDetails; k++) {
          kKeysDetails = new KeysRow(this, codeBase);
          vKeysRow.add(kKeysDetails);
        }
        fillRow(iTotalKeysDetails);
      }
    } catch (Exception ex) {
      ex.printStackTrace();
      KeylblError.setText(XMLFileErrorStr);
      KeylblError.setVisible(true);
    }
    String s;
    s = SysAddStaticLabelStr;
    s = s + "<" + codeBase + ">";
    SysAddStaticLabel.setText(s);
   }

  //Start the applet
  public void start() {
   }

  void mRefresh_actionPerformed(ActionEvent e) {
    try {
      String inputLine;
      URL codeBase1;
      codeBase1 = getCodeBase();
//      URL url1 = new URL(codeBase1);
      System.out.println(codeBase1);
      getAppletContext().showDocument(codeBase1);
    }
    catch (Exception ex) {
      String msg = new String("no refresh");
      System.out.println(msg);
      ex.printStackTrace();
    }

  }
  //Stop the applet
/*  public void stop() {
  }
  //Destroy the applet
  public void destroy() {
  }
*/
/**
 *
 * Action listener for buttons
 */

public void actionPerformed(ActionEvent e) {
  this.Btn_actionPerformed(e);
}

void Btn_actionPerformed(ActionEvent e) {
  if(e.getSource().equals(mRefresh))
   mRefresh_actionPerformed(e);
}

}

/**
* Class to represent a row of the key details
*/
class KeysRow extends Panel{
  ResourceBundle          resourceBundle;
  JLabel lblKeysH         = new JLabel();
  JLabel lblKeyType       = new JLabel();
  JLabel lblSerialNumber  = new JLabel();
  JLabel lblPartNumber    = new JLabel();
  JLabel lblHardLimit     = new JLabel();
  JLabel lblLicInUse      = new JLabel();
  JLabel lblHighestUse    = new JLabel();
  JLabel lblNumTimeOut    = new JLabel();
  int    serialNumber;  //To store the key serial number in decimal
  GridLayout gridLayout1  = new GridLayout();
  Border m_activeBorder   = new MatteBorder(1, 1, 1, 1, Color.yellow);

  URL codeBase;
  KeyInfoApplet parent;

  boolean   isResourceBundleFound = false;

  public KeysRow() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public KeysRow(KeyInfoApplet parent, URL uCodeBase) {
    try {
      codeBase = uCodeBase;
      this.parent = parent;
      jbInit();

    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    try{

      resourceBundle = ResourceBundle.getBundle("AppletResources");
                                                //, Locale.getDefault());
      //check if the resource bundle is present
      String testString = resourceBundle.getString("key");

      isResourceBundleFound = true;
    }catch (MissingResourceException e){
      isResourceBundleFound = false;
    }catch (NullPointerException en){
//    en.printStackTrace();
      isResourceBundleFound = false;
    }

    if(isResourceBundleFound == true)
    {
      lblKeysH.setText(resourceBundle.getString("lblKeysH"));
      lblKeyType.setText(resourceBundle.getString("lblKeyType"));
      lblSerialNumber.setText(resourceBundle.getString("lblSerialNumber"));
      lblPartNumber.setText(resourceBundle.getString("lblPartNumber"));
      lblHardLimit.setText(resourceBundle.getString("lblHardLimit"));
      lblLicInUse.setText(resourceBundle.getString("lblLicInUse"));
      lblHighestUse.setText(resourceBundle.getString("lblHighestUse"));
      lblNumTimeOut.setText(resourceBundle.getString("lblNumTimeOut"));
    }else{
      lblKeysH.setText("Keys#");
      lblKeyType.setText("Key Type");
      lblSerialNumber.setText("Serial Number");
      lblPartNumber.setText("Part Number");
      lblHardLimit.setText("Hard Limit");
      lblLicInUse.setText("Licenses-In-Use");
      lblHighestUse.setText("Highest Used");
      lblNumTimeOut.setText("Time-Outs ");
    }
      lblKeysH.addMouseListener(new LabelAdapter(this));

    this.setLayout(gridLayout1);
    this.add(lblKeysH, null);
    lblKeysH.setHorizontalAlignment(SwingConstants.CENTER);
    this.add(lblKeyType, null);
    lblKeyType.setHorizontalAlignment(SwingConstants.CENTER);
    this.add(lblSerialNumber, null);
    lblSerialNumber.setHorizontalAlignment(SwingConstants.CENTER);
    this.add(lblPartNumber, null);
    lblPartNumber.setHorizontalAlignment(SwingConstants.CENTER);
    this.add(lblHardLimit, null);
    lblHardLimit.setHorizontalAlignment(SwingConstants.CENTER);
    this.add(lblLicInUse, null);
    lblLicInUse.setHorizontalAlignment(SwingConstants.CENTER);
    this.add(lblHighestUse, null);
    lblHighestUse.setHorizontalAlignment(SwingConstants.CENTER);
    this.add(lblNumTimeOut, null);
    lblNumTimeOut.setHorizontalAlignment(SwingConstants.CENTER);


    lblKeysH.setBorder(BorderFactory.createLineBorder(Color.lightGray));
    lblKeysH.setFont(new java.awt.Font("Serif", 1, 16));
    lblKeysH.setForeground(SystemColor.activeCaption);
    lblKeyType.setBorder(BorderFactory.createLineBorder(Color.lightGray));
    lblKeyType.setFont(new java.awt.Font("Serif", 1, 16));
    lblKeyType.setForeground(SystemColor.activeCaption);
    lblSerialNumber.setBorder(BorderFactory.createLineBorder(Color.lightGray));
    lblSerialNumber.setFont(new java.awt.Font("Serif", 1, 16));
    lblSerialNumber.setForeground(SystemColor.activeCaption);
    lblPartNumber.setBorder(BorderFactory.createLineBorder(Color.lightGray));
    lblPartNumber.setFont(new java.awt.Font("Serif", 1, 16));
    lblPartNumber.setForeground(SystemColor.activeCaption);
    lblHardLimit.setBorder(BorderFactory.createLineBorder(Color.lightGray));
    lblHardLimit.setFont(new java.awt.Font("Serif", 1, 16));
    lblHardLimit.setForeground(SystemColor.activeCaption);
    lblLicInUse.setBorder(BorderFactory.createLineBorder(Color.lightGray));
    lblLicInUse.setFont(new java.awt.Font("Serif", 1, 16));
    lblLicInUse.setForeground(SystemColor.activeCaption);
    lblHighestUse.setBorder(BorderFactory.createLineBorder(Color.lightGray));
    lblHighestUse.setFont(new java.awt.Font("Serif", 1, 16));
    lblHighestUse.setForeground(SystemColor.activeCaption);
    lblNumTimeOut.setBorder(BorderFactory.createLineBorder(Color.lightGray));
    lblNumTimeOut.setFont(new java.awt.Font("Serif", 1, 16));
    lblNumTimeOut.setForeground(SystemColor.activeCaption);
  }

  /**
   * Make the cursor icon to HAND shape
   */
  void chageCursorHand(MouseEvent e) {
    if (this.lblKeysH.getText().compareTo("Keys#") != 0) {
      setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
      lblKeysH.setBorder(m_activeBorder);
      lblKeysH.repaint();
      }
  }

  /**
  * change mouse cursor icon to default
  */
  void chageCursorDefault(MouseEvent e) {
    if (this.lblKeysH.getText().compareTo("Keys#") != 0) {
      setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
      lblKeysH.setBorder(BorderFactory.createLineBorder(Color.lightGray));
      lblKeysH.repaint();
      }
  }

/**
* The Method to get the licenseinfo.html file from the server to get the license details.
* */

void displayLicenseDetails()
{
    String strSerialNumber;

  try {
    strSerialNumber = Integer.toString(this.serialNumber);

    URL url = new URL(codeBase + "licenseinfo.html" + "?" +
                      this.lblKeysH.getText() + "?" + strSerialNumber);

    System.out.println(url);
    parent.getAppletContext().showDocument(url);
   }
   catch (Exception ex) {
     System.out.println("Error in downloading the second Applet.");
     ex.printStackTrace();
  }

}

  /**
  * Send a request to the server for the license details for a selected key
  */
  void lblKeysH_mousePressed(MouseEvent e) {
    if (this.lblKeysH.getText().compareTo("Keys#") != 0) {
      displayLicenseDetails();
    }
  }
}

/**
* Class to process the mouse events generated
*/
class LabelAdapter extends java.awt.event.MouseAdapter {
  KeysRow adaptee;

  LabelAdapter(KeysRow adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseEntered(MouseEvent e) {
    adaptee.chageCursorHand(e);
  }
  public void mouseExited(MouseEvent e) {
    adaptee.chageCursorDefault(e);
  }
  public void mousePressed(MouseEvent e) {
    adaptee.lblKeysH_mousePressed(e);
  }
}
