/***************************************************************************
* LicenseInfoApplet.java
*
* (C) Copyright 2004 SafeNet, Inc. All rights reserved.
*
*
* Purpose     : To display the license details for a attached key using licenseinfo.xml.
*
*
* Refer to the ReadMe.pdf for customize details of Sentinel License Monitor.
*
****************************************************************************/

//imports
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import java.util.*;
import java.io.*;
import java.net.*;

/**
*The Applet to display the license information
*/
public class LicenseInfoApplet  extends Applet implements ActionListener{
//file to request from server for license details
  static public final String LICENSE_INFO_XML_FILE = "licenseinfo.xml";

  ResourceBundle              resourceBundle;
  //boolean variable for check the resource bundle
  boolean   isResourceBundleFound = false;

  Panel mCenterPanel          = new Panel();
  Panel mSouthPanel           = new Panel();
  Panel mNorthPanel           = new Panel();

  BorderLayout borderLayout1  = new BorderLayout();
  GridLayout gridLayout2      = new GridLayout();
  GridLayout gridLayout1      = new GridLayout();

  Label LicLine1Heading       = new Label();
  Label LicAddStaticLabel     = new Label();
  Label mLicTopHeadingLabel   = new Label();
  Label LiclblError           = new Label();
  Label mLicFootNoteLabel     = new Label();
  Label mCopyrightLabel       = new Label();

  LicenseRow headingRow       = new LicenseRow();

  String tmpString            = new String();
  String xmlBuffer            = new String("");
  Vector vLicenseRow          = new Vector(2,1);
  Vector tmpVector            = new Vector(2,1);

  LicenseRow kKeysDetails;
  JButton mBack = new JButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();

  //Construct the applet
  public LicenseInfoApplet() {
  }
  //Initialize the applet
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**
  * Method to pad the serial number.
  */
    static public String PadSerialNumber(int input) {

      int width = 8; //pad for 8 digit wide
      //convert the serial number into the hex to display
      String output = Integer.toHexString(input);
      //convert to uppercase
      output = output.toUpperCase();

      for (int i = width - output.length(); i > 0; i--) {
        output = "0" + output;
      }
      //prefix it with the 0x
      output = "0x" + output;
      return output;
    }

  /**
  *Function to fill the data into the rows
  */
  private void fillRow(int iTotalKeysDetails)
  {
    XMLParser xParser = new XMLParser();
    try{
      LicenseRow tmpLicenseRow = new LicenseRow();
      tmpVector = xParser.getXMLTagValue(xmlBuffer, "ClientIPAddress");
      for (int k = 0; k < iTotalKeysDetails; k++) {
        tmpLicenseRow = (LicenseRow) vLicenseRow.get(k);
        String s = tmpVector.elementAt(k).toString();
        tmpLicenseRow.lblClientIP.setText(s);
      }

      tmpVector = xParser.getXMLTagValue(xmlBuffer, "ClientUserName");
      if (!tmpVector.isEmpty()) {
        for (int k = 0; k < iTotalKeysDetails; k++) {
          tmpLicenseRow = (LicenseRow) vLicenseRow.get(k);
          tmpLicenseRow.lblClientUserName.setText(tmpVector.elementAt(k).toString());
        }
      }

      tmpVector = xParser.getXMLTagValue(xmlBuffer, "ClientLogTime");
      for (int k = 0; k < iTotalKeysDetails; k++) {
        tmpLicenseRow = (LicenseRow) vLicenseRow.get(k);
        tmpLicenseRow.lblClientLogTime.setText(tmpVector.elementAt(k).toString());
      }

      tmpVector = xParser.getXMLTagValue(xmlBuffer, "ClientProcessID");
      for (int k = 0; k < iTotalKeysDetails; k++) {
        tmpLicenseRow = (LicenseRow) vLicenseRow.get(k);
        tmpLicenseRow.lblClientPID.setText(tmpVector.elementAt(k).toString());
      }
      //Add the keys row panel in the mCenterPanel
      for (int k = 0; k < iTotalKeysDetails; k++) {
        mCenterPanel.add( ( (LicenseRow) vLicenseRow.get(k)), null);
      }
    }catch(Exception ex){
    }
  }

/**
   * The Method to get the licenseinfo.xml file from the server
   * */

void getLicenseInfoXML_File_from_Server(){
 String inputLine = null;
 try{
     URL rURL = new URL(getCodeBase() + this.LICENSE_INFO_XML_FILE);

     BufferedReader in = new BufferedReader(
                             new InputStreamReader(
                             rURL.openStream()));

      //get the contents of xml file in the buffer
      while ((inputLine = in.readLine()) != null)
        xmlBuffer = xmlBuffer + inputLine;

      in.close();  //close the BufferReader

   }catch (Exception ex) {
   }
 }


  /**
  *Applet initialization method
  */
  private void jbInit() throws Exception {
    String mLicFootNoteLabelStr = new String("Unable to obtain the login time and process ID for clients using the SFNT_SPN_DRIVER access mode.");
    String LicAddStaticLabelStr = new String("Serial Number: ");
    String LiclblErrorStr = new String("No License details available");
    String XMLFileErrorStr = new String("Error in downloading the license information file.");
    try{
      resourceBundle = ResourceBundle.getBundle("AppletResources");
                                                //, Locale.getDefault());
      //make a check if the bunde is present
      String tt = resourceBundle.getString("mLicTopHeadingLabel");
      isResourceBundleFound = true;
    }catch (MissingResourceException e){
//      e.printStackTrace();
      isResourceBundleFound = false;
    }catch (NullPointerException en){
//    en.printStackTrace();
      isResourceBundleFound = false;
    }
    //check if the resource bundle is found
    if(isResourceBundleFound == true)
    {
      mLicTopHeadingLabel.setText(resourceBundle.getString("mLicTopHeadingLabel"));
      LicLine1Heading.setText(resourceBundle.getString("LicLine1Heading"));
      mCopyrightLabel.setText(resourceBundle.getString("mCopyrightLabel"));
      mBack.setText(resourceBundle.getString("mBack"));
      mLicFootNoteLabelStr  = resourceBundle.getString("mLicFootNoteLabel");
      LicAddStaticLabelStr = resourceBundle.getString("LicAddStaticLabel");
      LiclblErrorStr = resourceBundle.getString("LiclblError");
      XMLFileErrorStr = resourceBundle.getString("XMLLicFileError");
    }else{
      mLicTopHeadingLabel.setText("License Usage for the Key");
      LicLine1Heading.setText("Following are the usage details of each license available with key.");
      mCopyrightLabel.setText("Copyright 2004 SafeNet, Inc.");
      mBack.setText("Back");
    }

    this.setLayout(borderLayout1);
    mNorthPanel.setLayout(gridLayout1);
    mLicTopHeadingLabel.setBackground(SystemColor.activeCaption);
    mLicTopHeadingLabel.setFont(new java.awt.Font("Serif", 1, 24));
    mLicTopHeadingLabel.setForeground(Color.white);
    gridLayout1.setColumns(0);
    gridLayout1.setRows(5);

    LicAddStaticLabel.setBackground(Color.white);
    LicAddStaticLabel.setFont(new java.awt.Font("Serif", 1, 15));
    LicAddStaticLabel.setForeground(SystemColor.activeCaption);

    mCenterPanel.setLayout(gridLayout2);
    LicLine1Heading.setBackground(Color.white);
    LicLine1Heading.setFont(new java.awt.Font("Serif", 1, 14));
    LicLine1Heading.setForeground(SystemColor.activeCaption);
    gridLayout2.setRows(12);

    //The * is the mark for footnote.
    String footNote = new String("* ");
    footNote = footNote + mLicFootNoteLabelStr;
    mLicFootNoteLabel.setText(footNote);

    mLicFootNoteLabel.setBackground(Color.white);
    mLicFootNoteLabel.setFont(new java.awt.Font("Serif", 0, 14));
    mLicFootNoteLabel.setForeground(new Color(0, 0, 90));

    mCopyrightLabel.setBackground(Color.white);
    mCopyrightLabel.setFont(new java.awt.Font("Serif", 0, 14));
    mCopyrightLabel.setForeground(new Color(0, 0, 90));

    mBack.setMinimumSize(new Dimension(90, 25));
    mBack.setPreferredSize(new Dimension(90, 25));
//    mBack.addActionListener(new BackAdapter(this));
    mBack.addActionListener(this);

    LiclblError.setBackground(Color.white);
    LiclblError.setFont(new java.awt.Font("Serif", 1, 14));
    LiclblError.setForeground(Color.red);
    LiclblError.setVisible(false);
    this.setBackground(Color.white);
    this.setForeground(Color.white);
    mCenterPanel.setBackground(Color.white);
    mCenterPanel.setForeground(Color.black);
    mSouthPanel.setBackground(Color.white);
    mSouthPanel.setLayout(gridBagLayout1);

    mNorthPanel.setBackground(Color.white);
    mCenterPanel.add(headingRow,null);

    JScrollPane mScrollPane = new JScrollPane();

    this.add(mScrollPane, BorderLayout.CENTER);
    mScrollPane.getViewport().add(mCenterPanel, null);
    mScrollPane.setBorder(BorderFactory.createEmptyBorder());
    this.add(mSouthPanel, BorderLayout.SOUTH);
    this.add(mNorthPanel, BorderLayout.NORTH);
    mNorthPanel.add(mLicTopHeadingLabel, null);
    mNorthPanel.add(LicAddStaticLabel, null);
    mNorthPanel.add(LicLine1Heading, null);
    mNorthPanel.add(LiclblError, null);

    mSouthPanel.add(mLicFootNoteLabel,   new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    mSouthPanel.add(mCopyrightLabel,    new GridBagConstraints(0, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    mSouthPanel.add(mBack,   new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));


    //Request for the licenseinfo.xml file to server
    try {
      getLicenseInfoXML_File_from_Server();
      XMLParser xParser = new XMLParser();

      //get the serial number from the licenseinfo file to display.
      tmpVector = xParser.getXMLTagValue(xmlBuffer, "SerialNumber");
      String finalSerialNumberToDisplay;

      String strSerialNumber = tmpVector.elementAt(0).toString();

      //get the serial number in decimal
      int iSerialNumber = Integer.parseInt(strSerialNumber);
      //pad the serial number to displays
      strSerialNumber = PadSerialNumber(iSerialNumber);

      finalSerialNumberToDisplay = LicAddStaticLabelStr + strSerialNumber;
      LicAddStaticLabel.setText(finalSerialNumberToDisplay);

      //get the number of keys Info in file
      tmpVector = xParser.getXMLTagValue(xmlBuffer, "LicenseDetails");
      if(tmpVector.isEmpty()){
        //Give the message for no keys details found in the xml file.
        LiclblError.setText(LiclblErrorStr);
        LiclblError.setVisible(true);
        return;
      }
      //Get the total number of keys
      int iTotalKeysDetails = 0;

      iTotalKeysDetails = tmpVector.size();
      //Manipulation with the rowss
      if (iTotalKeysDetails > 9)
        gridLayout2.setRows(iTotalKeysDetails + 3);

      for (int k = 0; k < iTotalKeysDetails; k++) {
        kKeysDetails = new LicenseRow();
        vLicenseRow.add(kKeysDetails);
      }

      fillRow(iTotalKeysDetails);

    } catch (Exception ex) {
      LiclblError.setText(XMLFileErrorStr);
      LiclblError.setVisible(true);
    }
  }


  //Start the applet
  public void start() {
  }
  //Stop the applet
/*  public void stop() {
  }
  //Destroy the applet
  public void destroy() {
  }
*/


void mBack_actionPerformed(ActionEvent e) {
  try {
    String inputLine;
    URL codeBase1;
    codeBase1 = getCodeBase();
//      URL url1 = new URL(codeBase1);
    System.out.println(codeBase1);
    getAppletContext().showDocument(codeBase1);
  }
  catch (Exception ex) {
    String msg = new String("no refresh");
    System.out.println(msg);
    ex.printStackTrace();
  }
}

 /**
  *
  * Action listener for buttons
  */

 public void actionPerformed(ActionEvent e) {
   this.Btn_actionPerformed(e);
 }

 void Btn_actionPerformed(ActionEvent e) {
   if(e.getSource().equals(mBack))
    mBack_actionPerformed(e);
 }

}

/**
* Class to represent a row of the key details
*/
class LicenseRow extends Panel {
  ResourceBundle            resourceBundle;
  boolean   isResourceBundleFound = false;

  JLabel lblClientIP        = new JLabel();
  JLabel lblClientUserName  = new JLabel();
  JLabel lblClientLogTime   = new JLabel();
  JLabel lblClientPID       = new JLabel();
  GridLayout gridLayout1    = new GridLayout();

  public LicenseRow() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    try{
      resourceBundle = ResourceBundle.getBundle("AppletResources");
                                                //, Locale.getDefault());

      //check if the resource bundle is present
      String testString = resourceBundle.getString("key");
      isResourceBundleFound = true;
    }catch (MissingResourceException e){
      isResourceBundleFound = false;
    }catch (NullPointerException en){
//    en.printStackTrace();
      isResourceBundleFound = false;
    }

    if(isResourceBundleFound == true)
    {
      lblClientIP.setText(resourceBundle.getString("lblClientIP"));
      lblClientUserName.setText(resourceBundle.getString("lblClientUserName"));
      lblClientLogTime.setText(resourceBundle.getString("lblClientLogTime"));
      lblClientPID.setText(resourceBundle.getString("lblClientPID"));
    }else{
      lblClientIP.setText("Client/Access Mode");
      lblClientUserName.setText("User Name");
      lblClientLogTime.setText("Client login time");
      lblClientPID.setText("Client Process ID");
    }


    this.setLayout(gridLayout1);

    this.add(lblClientIP, null);
    lblClientIP.setHorizontalAlignment(SwingConstants.CENTER);
    this.add(lblClientUserName, null);
    lblClientUserName.setHorizontalAlignment(SwingConstants.CENTER);
    this.add(lblClientLogTime, null);
    lblClientLogTime.setHorizontalAlignment(SwingConstants.CENTER);
    this.add(lblClientPID, null);
    lblClientPID.setHorizontalAlignment(SwingConstants.CENTER);

    lblClientIP.setBorder(BorderFactory.createLineBorder(Color.lightGray));
    lblClientIP.setFont(new java.awt.Font("Serif", 1, 16));
    lblClientIP.setForeground(SystemColor.activeCaption);
    lblClientUserName.setBorder(BorderFactory.createLineBorder(Color.lightGray));
    lblClientUserName.setFont(new java.awt.Font("Serif", 1, 16));
    lblClientUserName.setForeground(SystemColor.activeCaption);
    lblClientLogTime.setBorder(BorderFactory.createLineBorder(Color.lightGray));
    lblClientLogTime.setFont(new java.awt.Font("Serif", 1, 16));
    lblClientLogTime.setForeground(SystemColor.activeCaption);
    lblClientPID.setBorder(BorderFactory.createLineBorder(Color.lightGray));
    lblClientPID.setFont(new java.awt.Font("Serif", 1, 16));
    lblClientPID.setForeground(SystemColor.activeCaption);
  }
}
